## neko 1.6.0

=== Makefile ===
## CONFIG

INSTALL_PREFIX = /usr/local

CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm -DCOMPACT_TABLE
EXTFLAGS = -pthread
MAKESO = $(CC) -shared -WBsymbolic
LIBNEKO_NAME = libneko.so
LIBNEKO_LIBS = -ldl -lgc -lm
NEKOVM_FLAGS = -Lbin -lneko
STD_NDLL_FLAGS = ${NEKOVM_FLAGS}
INSTALL_FLAGS =

NEKO_EXEC = LD_LIBRARY_PATH=../bin:${LD_LIBRARY_PATH} NEKOPATH=../boot:../bin ../bin/neko

# For OSX
#
# MACOSX = 1

# For OSX Universal Binaries
#
# OSX_UNIVERSAL = 1


# For 64 bit
#
# CFLAGS += -D_64BITS

# For profiling VM
#
# CFLAGS += -DNEKO_PROF

# For lower memory usage (takes more CPU !)
#
# CFLAGS += -DLOW_MEM

# For MINGW/MSYS

ifeq (${WIN32}, 1)
CFLAGS = -g -Wall -O3 -momit-leaf-frame-pointer -I vm -I /usr/local/include -DCOMPACT_TABLE
EXTFLAGS =
MAKESO = $(CC) -O -shared
LIBNEKO_NAME = neko.dll
LIBNEKO_LIBS = -Lbin -lgc
STD_NDLL_FLAGS = ${NEKOVM_FLAGS} -lws2_32
endif

### OSX SPECIFIC

ifeq (${UNIVERSAL},1)
MACOSX=1
OSX_UNIVERSAL=1
endif

ifeq (${MACOSX}, 1)
export MACOSX_DEPLOYMENT_TARGET=10.3
EXTFLAGS =
MAKESO = ${CC}
LIBNEKO_NAME = libneko.dylib
LIBNEKO_INSTALL = -install_name @executable_path/${LIBNEKO_NAME}
LIBNEKO_LIBS = -ldl -lgc -lm -dynamiclib -single_module ${LIBNEKO_INSTALL}
NEKOVM_FLAGS = -L${PWD}/bin -lneko
STD_NDLL_FLAGS = -bundle -undefined dynamic_lookup ${NEKOVM_FLAGS}

ifeq (${OSX_UNIVERSAL}, 1)

export MACOSX_DEPLOYMENT_TARGET_i386=10.4
export MACOSX_DEPLOYMENT_TARGET_ppc=10.3
CFLAGS += -arch ppc -arch i386 -L/usr/local/lib
UNIV = libs/include/osx_universal
#linking to shared lib (.a) explicitly:
LIBNEKO_DEPS = ${UNIV}/libgc.a  -lSystemStubs
LIBNEKO_LIBS = ${LIBNEKO_DEPS} -dynamiclib -single_module ${LIBNEKO_INSTALL} ${CFLAGS}
NEKOVM_FLAGS = -L${PWD}/bin -lneko
STD_NDLL_FLAGS = -bundle ${NEKOVM_FLAGS} ${CFLAGS}
INSTALL_FLAGS = -osx-universal

endif

endif

### MAKE

VM_OBJECTS = vm/main.o
STD_OBJECTS = libs/std/buffer.o libs/std/date.o libs/std/file.o libs/std/init.o libs/std/int32.o libs/std/math.o libs/std/string.o libs/std/random.o libs/std/serialize.o libs/std/socket.o libs/std/sys.o libs/std/xml.o libs/std/module.o libs/std/md5.o libs/std/utf8.o libs/std/memory.o libs/std/misc.o libs/std/thread.o libs/std/process.o
LIBNEKO_OBJECTS = vm/alloc.o vm/builtins.o vm/callback.o vm/context.o vm/interp.o vm/load.o vm/objtable.o vm/others.o vm/hash.o vm/module.o vm/jit_x86.o

all: createbin libneko neko std compiler libs

universal:
	make MACOSX=1 OSX_UNIVERSAL=1

createbin:
	-mkdir bin 2>/dev/null

libneko: bin/${LIBNEKO_NAME}

libs:
	(cd src; ${NEKO_EXEC} nekoc tools/install.neko)
	(cd src; ${NEKO_EXEC} tools/install ${INSTALL_FLAGS})

doc:
	(cd src; ${NEKO_EXEC} nekoc tools/makedoc.neko)
	(cd src; ${NEKO_EXEC} tools/makedoc)

test:
	(cd src; ${NEKO_EXEC} nekoc tools/test.neko)
	(cd src; ${NEKO_EXEC} tools/test)

neko: bin/neko

std: bin/std.ndll

compiler:
	(cd src; ${NEKO_EXEC} nekoml -v neko/Main.nml nekoml/Main.nml)
	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoc.n neko/Main)
	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoml.n nekoml/Main)

bin/${LIBNEKO_NAME}: ${LIBNEKO_OBJECTS}
	${MAKESO} ${EXTFLAGS} -o $@ ${LIBNEKO_OBJECTS} ${LIBNEKO_LIBS}

bin/neko: $(VM_OBJECTS)
	${CC} ${CFLAGS} ${EXTFLAGS} -o $@ ${VM_OBJECTS} ${NEKOVM_FLAGS}
	strip bin/neko

bin/std.ndll: ${STD_OBJECTS}
	${MAKESO} -o $@ ${STD_OBJECTS} ${STD_NDLL_FLAGS}

clean:
	rm -rf bin/${LIBNEKO_NAME} ${LIBNEKO_OBJECTS} ${VM_OBJECTS}
	rm -rf bin/neko bin/nekoc bin/nekoml bin/nekotools
	rm -rf bin/std bin/*.ndll bin/*.n libs/*/*.o
	rm -rf src/*.n src/neko/*.n src/nekoml/*.n src/tools/*.n
	rm -rf bin/mtypes bin/tools

install:
	cp bin/${LIBNEKO_NAME} ${INSTALL_PREFIX}/lib
	cp bin/neko bin/nekoc bin/nekotools ${INSTALL_PREFIX}/bin
	-mkdir ${INSTALL_PREFIX}/lib/neko
	cp bin/*.ndll ${INSTALL_PREFIX}/lib/neko
	-mkdir ${INSTALL_PREFIX}/include
	cp vm/neko*.h ${INSTALL_PREFIX}/include

uninstall:
	rm -rf ${INSTALL_PREFIX}/lib/${LIBNEKO_NAME}
	rm -rf ${INSTALL_PREFIX}/bin/neko ${INSTALL_PREFIX}/bin/nekoc ${INSTALL_PREFIX}/bin/nekotools
	rm -rf ${INSTALL_PREFIX}/lib/neko

.SUFFIXES : .c .o

.c.o :
	${CC} ${CFLAGS} ${EXTFLAGS} -o $@ -c $<

.PHONY: all libneko libs neko std compiler clean doc test

## neko 1.7.0

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 INSTALL_PREFIX = /usr/local
 
-CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm -DCOMPACT_TABLE
+CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm
 EXTFLAGS = -pthread
 MAKESO = $(CC) -shared -WBsymbolic
 LIBNEKO_NAME = libneko.so
@@ -37,7 +37,7 @@
 # For MINGW/MSYS
 
 ifeq (${WIN32}, 1)
-CFLAGS = -g -Wall -O3 -momit-leaf-frame-pointer -I vm -I /usr/local/include -DCOMPACT_TABLE
+CFLAGS = -g -Wall -O3 -momit-leaf-frame-pointer -I vm -I /usr/local/include
 EXTFLAGS =
 MAKESO = $(CC) -O -shared
 LIBNEKO_NAME = neko.dll
@@ -81,7 +81,7 @@
 
 ### MAKE
 
-VM_OBJECTS = vm/main.o
+VM_OBJECTS = vm/stats.o vm/main.o
 STD_OBJECTS = libs/std/buffer.o libs/std/date.o libs/std/file.o libs/std/init.o libs/std/int32.o libs/std/math.o libs/std/string.o libs/std/random.o libs/std/serialize.o libs/std/socket.o libs/std/sys.o libs/std/xml.o libs/std/module.o libs/std/md5.o libs/std/utf8.o libs/std/memory.o libs/std/misc.o libs/std/thread.o libs/std/process.o
 LIBNEKO_OBJECTS = vm/alloc.o vm/builtins.o vm/callback.o vm/context.o vm/interp.o vm/load.o vm/objtable.o vm/others.o vm/hash.o vm/module.o vm/jit_x86.o

## neko 1.8.1

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 INSTALL_PREFIX = /usr/local
 
-CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm
+CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm -D_GNU_SOURCE
 EXTFLAGS = -pthread
 MAKESO = $(CC) -shared -WBsymbolic
 LIBNEKO_NAME = libneko.so
@@ -66,7 +66,7 @@
 
 export MACOSX_DEPLOYMENT_TARGET_i386=10.4
 export MACOSX_DEPLOYMENT_TARGET_ppc=10.3
-CFLAGS += -arch ppc -arch i386 -L/usr/local/lib
+CFLAGS += -arch ppc -arch i386 -L/usr/local/lib -L/opt/local/lib -I/opt/local/include
 UNIV = libs/include/osx_universal
 #linking to shared lib (.a) explicitly:
 LIBNEKO_DEPS = ${UNIV}/libgc.a  -lSystemStubs
@@ -83,7 +83,7 @@
 
 VM_OBJECTS = vm/stats.o vm/main.o
 STD_OBJECTS = libs/std/buffer.o libs/std/date.o libs/std/file.o libs/std/init.o libs/std/int32.o libs/std/math.o libs/std/string.o libs/std/random.o libs/std/serialize.o libs/std/socket.o libs/std/sys.o libs/std/xml.o libs/std/module.o libs/std/md5.o libs/std/utf8.o libs/std/memory.o libs/std/misc.o libs/std/thread.o libs/std/process.o
-LIBNEKO_OBJECTS = vm/alloc.o vm/builtins.o vm/callback.o vm/context.o vm/interp.o vm/load.o vm/objtable.o vm/others.o vm/hash.o vm/module.o vm/jit_x86.o
+LIBNEKO_OBJECTS = vm/alloc.o vm/builtins.o vm/callback.o vm/interp.o vm/load.o vm/objtable.o vm/others.o vm/hash.o vm/module.o vm/jit_x86.o vm/threads.o
 
 all: createbin libneko neko std compiler libs
 
@@ -112,7 +112,7 @@
 std: bin/std.ndll
 
 compiler:
-	(cd src; ${NEKO_EXEC} nekoml -v neko/Main.nml nekoml/Main.nml)
+	(cd src; ${NEKO_EXEC} nekoml -nostd neko/Main.nml nekoml/Main.nml)
 	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoc.n neko/Main)
 	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoml.n nekoml/Main)
 
@@ -135,7 +135,7 @@
 
 install:
 	cp bin/${LIBNEKO_NAME} ${INSTALL_PREFIX}/lib
-	cp bin/neko bin/nekoc bin/nekotools ${INSTALL_PREFIX}/bin
+	cp bin/neko bin/nekoc bin/nekotools bin/nekoml bin/nekoml.std ${INSTALL_PREFIX}/bin
 	-mkdir ${INSTALL_PREFIX}/lib/neko
 	cp bin/*.ndll ${INSTALL_PREFIX}/lib/neko
 	-mkdir ${INSTALL_PREFIX}/include

=== debian/changelog ===
neko (1.8.1-6ubuntu4) raring; urgency=low

  * Rebuild to pick up the new libgc1c3 dependency.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Feb 2013 13:39:51 +0000

neko (1.8.1-6ubuntu3) quantal; urgency=low

  * Rebuild to correct the compile-time-selected linker path on armhf.
  * Move the as-needed fix from a debian-changes patch to its own.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 11 Oct 2012 00:03:59 -0600

neko (1.8.1-6ubuntu2) precise; urgency=low

  * Rebuild for libmysqlclient transition

 -- Clint Byrum <clint@ubuntu.com>  Wed, 23 Nov 2011 23:58:41 -0800

neko (1.8.1-6ubuntu1) oneiric; urgency=low

  * Fix FTBFS with ld --as-needed. LP: #771060.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Sep 2011 15:45:59 +0200

neko (1.8.1-6) unstable; urgency=low

  * Include patch to fix compile errors on hurd-i386, thanks to Pino
    Toscano.
    (Closes: #626260)

 -- Jens Peter Secher <jps@debian.org>  Sun, 15 May 2011 18:44:31 +0200

neko (1.8.1-5) unstable; urgency=low

  * Avoid spurious build failures (stack overflows and segmentation
    faults) by using both -fno-strict-aliasing and lower optimisation
    level.
    (Closes: #569806)

 -- Jens Peter Secher <jps@debian.org>  Thu, 18 Feb 2010 22:26:27 +0100

neko (1.8.1-4) unstable; urgency=low

  * Attempt to fix executable_path() on kFreeBSD, which only seemed to
    work when invoked from bash, thanks to Roman Neuhauser.

 -- Jens Peter Secher <jps@debian.org>  Sat, 13 Feb 2010 16:34:13 +0100

neko (1.8.1-3) unstable; urgency=low

  * Converted to dpkg-source format 3.0 (quilt).
  * Use mercurial-buildpackage for repository maintenance, so old
    repository does not exist any more.
  * Bumped Standards-Version to 3.8.4, no change.
  * Use misc:Depends macro for all binary packages, and tighten depency
    for the header-files package.

 -- Jens Peter Secher <jps@debian.org>  Sat, 13 Feb 2010 15:20:34 +0100

neko (1.8.1-2) unstable; urgency=low

  * Do not install broken mysql5.ndll library.  The dynamically linked
    mysql.ndll works fine for all versions of MySql.
    (Closes: #542024)
  * Build-Depend on generic libmysqlclient-dev instead of specific
    version.
  * Fixed build failure on kFreeBSD, thanks to Cyril Brulebois.
    (Closes: #543995)
  * Bumped the Standards-Version to 3.8.3, no changes.

 -- Jens Peter Secher <jps@debian.org>  Wed, 09 Sep 2009 14:40:17 +0200

neko (1.8.1-1) unstable; urgency=low

  * New upstream version.
  * Bump SONAME to libneko.0.1 and make libneko0 conflict with previous
    version of neko-dev.
  * Change libapache2-mod-neko package section to httpd, and updated
    Standards-Version to 3.8.2.
  * Removed obsolete patch tora-pwrite-diversion.diff.
  * Added tora-missing-include.diff to include stdlib.h.
  * Added mysql-missing-include.diff to include stdlib.h.
    
 -- Jens Peter Secher <jps@debian.org>  Tue, 28 Jul 2009 22:32:00 +0200

neko (1.8.0-4) unstable; urgency=low

  * Fix broken NDLLs (shared libraries) by reverting some of the previous
    changes.

 -- Jens Peter Secher <jps@debian.org>  Sat, 28 Mar 2009 09:40:24 +0100

neko (1.8.0-3) unstable; urgency=low

  * Fix build failure on MIPS by tightening up the linking process.
  * Make neko-dev architecture independent since there are no binary files
    in neko-dev.
  * Bumped the Standards-Version to 3.8.1.
  * Bumped debhelper version to 7.

 -- Jens Peter Secher <jps@debian.org>  Thu, 26 Mar 2009 20:00:40 +0100

neko (1.8.0-2) unstable; urgency=low

  * Promoted libneko to a proper shared library living in /usr/lib.
    (Closes: #509454)    
  * No need to Build-Conflict with itself because all rpaths have been
    removed.
  * Use quilt instead of dpatch for patches, and describe how to use
    quilt in Debian.source (thanks to Russ Allbery).
  * Strip all shared libraries.
  * Put test.n and test.neko in examples directory.
  * Added a Vcs-Hg control filed to indicate the location of the public
    repository.
  * Bumped the Standards-Version to 3.8.0.

 -- Jens Peter Secher <jps@debian.org>  Sat, 14 Mar 2009 21:01:12 +0100

neko (1.8.0-1) experimental; urgency=low

  * New upstream release.
  * Bumped debhelper version to 6.

 -- Jens Peter Secher <jps@debian.org>  Sat, 04 Oct 2008 16:44:58 +0200

neko (1.7.1-1~bpo40+1) etch-backports; urgency=low

  * Backport to Etch (no change).

 -- Jens Peter Secher <jps@debian.org>  Sun, 03 Aug 2008 13:32:05 +0200

neko (1.7.1-1) unstable; urgency=low

  * New upstream release.
  * Call dh_makeshlibs before dh_installdeb in debian/rules.
  * Define _GNU_SOURCE to get threads to work.

 -- Jens Peter Secher <jps@debian.org>  Thu, 31 Jul 2008 13:17:14 +0200

neko (1.7.0-1) unstable; urgency=low

  * New upstream release.

 -- Jens Peter Secher <jps@debian.org>  Thu, 27 Mar 2008 20:53:37 +0100

neko (1.6.0-4~bpo40+2) etch-backports; urgency=low

  * Pass version extracted by dpkg-parsechangelog to dh_makeshlibs instead
    of error prone hard-coding.

 -- Jens Peter Secher <jps@debian.org>  Tue, 27 Nov 2007 21:09:43 +0100

neko (1.6.0-4~bpo40+1) etch-backports; urgency=low

  * Without the Homepage field.

 -- Jens Peter Secher <jps@debian.org>  Tue, 27 Nov 2007 21:09:43 +0100

neko (1.6.0-4) unstable; urgency=low

  * Give libneko a proper SONAME to avoid breakage by new dpkg-shlibdeps.
  * Avoid a lot of unnecessary shared library dependencies.
  * Place the apache module in section web.
  * Use the Homepage field in the control file.
  * Bump debhelper to version 5.

 -- Jens Peter Secher <jps@debian.org>  Mon, 26 Nov 2007 19:03:00 +0100

neko (1.6.0-3) unstable; urgency=low

  * Fixed missing reference to shared mysqlclient library.

 -- Jens Peter Secher <jps@debian.org>  Tue, 13 Nov 2007 00:42:42 +0100

neko (1.6.0-2~bpo40+1) etch-backports; urgency=low

  * Backport to Etch (no change).

 -- Jens Peter Secher <jps@debian.org>  Sat, 08 Sep 2007 14:16:50 +0200

neko (1.6.0-2) unstable; urgency=low

  * Support non-stripped builds (DEB_BUILD_OPTIONS=nostrip).


=== debian/rules ===
#!/usr/bin/make -f
## debian/rules for neko.

## General compile options.
cflags := -Wall -fPIC -fomit-frame-pointer -I vm -DCOMPACT_TABLE -D_GNU_SOURCE -g

## Both AMD64 and all kFreeBSDs seem to have problems with the type
## punning used in the Neko source.
ifeq (amd64,$(DEB_HOST_ARCH))
        cflags += -fno-strict-aliasing
endif
ifeq (kfreebsd,$(DEB_HOST_ARCH_OS))
        cflags += -fno-strict-aliasing
endif
ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	cflags += -O2
else
	cflags += -O0
endif

build: build-stamp

build-stamp:
	dh_testdir
	make CFLAGS="$(cflags)"
	touch $@

debian := $(CURDIR)/debian
overrides := usr/share/lintian/overrides

binary-indep: build
	dh_testdir
	dh_testroot
	dh_install -plibapache2-mod-neko -pneko-dev
	dh_installdocs -plibapache2-mod-neko -pneko-dev
	dh_installchangelogs -plibapache2-mod-neko -pneko-dev CHANGES
	dh_compress -plibapache2-mod-neko -pneko-dev
	dh_fixperms -plibapache2-mod-neko -pneko-dev
	dh_installdeb -plibapache2-mod-neko -pneko-dev
	dh_gencontrol -plibapache2-mod-neko -pneko-dev
	dh_md5sums -plibapache2-mod-neko -pneko-dev
	dh_builddeb -plibapache2-mod-neko -pneko-dev

binary-arch: build
	dh_testdir
	dh_testroot
	dh_install -a
	mkdir -p $(debian)/neko/$(overrides)
	cp $(debian)/neko.lintian-overrides $(debian)/neko/$(overrides)/neko
	dh_installdocs -a
	dh_installexamples -a
	dh_installchangelogs -a CHANGES
	dh_installman -pneko debian/neko.1 debian/nekoc.1 debian/nekotools.1
	dh_strip -a -Xnekoc -Xnekotools
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs
	dh_installdeb -a
	dh_shlibdeps -a
	find $(debian) -name '*.ndll' -exec chmod -x '{}' ';'
	find $(debian) -name '*.neko' -exec chmod -x '{}' ';'
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

clean:
	dh_testdir
	dh_testroot
	-rm -f *-stamp
	make clean
	dh_clean

.PHONY: binary binary-indep binary-arch build clean

## neko 2.0.0

=== Makefile ===
# This Makefile works by default for Linux
# You can active other OS support by compiling with the following options
#
# For OSX
#   make os=osx
#
# For MingW/MSys
#   make os=mingw
#

## CONFIG

INSTALL_PREFIX = /usr/local

CFLAGS = -Wall -O3 -fPIC -fomit-frame-pointer -I vm -D_GNU_SOURCE -I libs/common
EXTFLAGS = -pthread
MAKESO = $(CC) -shared -Wl,-Bsymbolic
LIBNEKO_NAME = libneko.so
LIBNEKO_LIBS = -ldl -lgc -lm
NEKOVM_FLAGS = -Lbin -lneko
STD_NDLL_FLAGS = ${NEKOVM_FLAGS} -lrt
INSTALL_FLAGS =

NEKO_EXEC = LD_LIBRARY_PATH=../bin:${LD_LIBRARY_PATH} NEKOPATH=../boot:../bin ../bin/neko

# For profiling VM
#
# CFLAGS += -DNEKO_PROF

# For lower memory usage (takes more CPU !)
#
# CFLAGS += -DLOW_MEM

## MINGW SPECIFIC

ifeq (${os}, mingw)
CFLAGS = -g -Wall -O3 -momit-leaf-frame-pointer -I vm -I /usr/local/include -I libs/common
EXTFLAGS =
MAKESO = $(CC) -O -shared
LIBNEKO_NAME = neko.dll
LIBNEKO_LIBS = -Lbin -lgc
STD_NDLL_FLAGS = ${NEKOVM_FLAGS} -lws2_32
endif

### OSX SPECIFIC

ifeq (${os}, osx)
export MACOSX_DEPLOYMENT_TARGET=10.4
EXTFLAGS =
MAKESO = ${CC}
LIBNEKO_NAME = libneko.dylib
LIBNEKO_INSTALL = -install_name @executable_path/${LIBNEKO_NAME}
LIBNEKO_LIBS = -ldl /opt/local/lib/libgc.a -lm -dynamiclib -single_module ${LIBNEKO_INSTALL}
NEKOVM_FLAGS = -L${CURDIR}/bin -lneko
STD_NDLL_FLAGS = -bundle -undefined dynamic_lookup ${NEKOVM_FLAGS}
CFLAGS += -L/usr/local/lib -L/opt/local/lib -I/opt/local/include
INSTALL_FLAGS = -static

endif

### MAKE

VM_OBJECTS = vm/stats.o vm/main.o
STD_OBJECTS = libs/std/buffer.o libs/std/date.o libs/std/file.o libs/std/init.o libs/std/int32.o libs/std/math.o libs/std/string.o libs/std/random.o libs/std/serialize.o libs/std/socket.o libs/std/sys.o libs/std/xml.o libs/std/module.o libs/common/sha1.o libs/std/md5.o libs/std/utf8.o libs/std/memory.o libs/std/misc.o libs/std/thread.o libs/std/process.o
LIBNEKO_OBJECTS = vm/alloc.o vm/builtins.o vm/callback.o vm/interp.o vm/load.o vm/objtable.o vm/others.o vm/hash.o vm/module.o vm/jit_x86.o vm/threads.o

all: createbin libneko neko std compiler libs

createbin:
	-mkdir bin 2>/dev/null

libneko: bin/${LIBNEKO_NAME}

libs:
	(cd src; ${NEKO_EXEC} nekoc tools/install.neko)
	(cd src; ${NEKO_EXEC} tools/install ${INSTALL_FLAGS})

tools:
	(cd src; ${NEKO_EXEC} nekoc tools/install.neko)
	(cd src; ${NEKO_EXEC} tools/install -nolibs)
	
doc:
	(cd src; ${NEKO_EXEC} nekoc tools/makedoc.neko)
	(cd src; ${NEKO_EXEC} tools/makedoc)

test:
	(cd src; ${NEKO_EXEC} nekoc tools/test.neko)
	(cd src; ${NEKO_EXEC} tools/test)

neko: bin/neko

std: bin/std.ndll

compiler:
	(cd src; ${NEKO_EXEC} nekoml -nostd neko/Main.nml nekoml/Main.nml)
	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoc.n neko/Main)
	(cd src; ${NEKO_EXEC} nekoc -link ../boot/nekoml.n nekoml/Main)

bin/${LIBNEKO_NAME}: ${LIBNEKO_OBJECTS}
	${MAKESO} ${EXTFLAGS} -o $@ ${LIBNEKO_OBJECTS} ${LIBNEKO_LIBS}

bin/neko: $(VM_OBJECTS)
	${CC} ${CFLAGS} ${EXTFLAGS} -o $@ ${VM_OBJECTS} ${NEKOVM_FLAGS}
	strip bin/neko

bin/std.ndll: ${STD_OBJECTS}
	${MAKESO} -o $@ ${STD_OBJECTS} ${STD_NDLL_FLAGS}

clean:
	rm -rf bin/${LIBNEKO_NAME} ${LIBNEKO_OBJECTS} ${VM_OBJECTS}
	rm -rf bin/neko bin/nekoc bin/nekoml bin/nekotools
	rm -rf bin/std bin/*.ndll bin/*.n libs/*/*.o
	rm -rf src/*.n src/neko/*.n src/nekoml/*.n src/tools/*.n
	rm -rf bin/mtypes bin/tools

install:
	cp bin/${LIBNEKO_NAME} ${INSTALL_PREFIX}/lib
	cp bin/neko bin/nekoc bin/nekotools bin/nekoml bin/nekoml.std ${INSTALL_PREFIX}/bin
	-mkdir ${INSTALL_PREFIX}/lib/neko
	cp bin/*.ndll ${INSTALL_PREFIX}/lib/neko
	-mkdir ${INSTALL_PREFIX}/include
	cp vm/neko*.h ${INSTALL_PREFIX}/include

uninstall:
	rm -rf ${INSTALL_PREFIX}/lib/${LIBNEKO_NAME}
	rm -rf ${INSTALL_PREFIX}/bin/neko ${INSTALL_PREFIX}/bin/nekoc ${INSTALL_PREFIX}/bin/nekotools
	rm -rf ${INSTALL_PREFIX}/lib/neko

.SUFFIXES : .c .o

.c.o :
	${CC} ${CFLAGS} ${EXTFLAGS} -o $@ -c $<

.PHONY: all libneko libs neko std compiler clean doc test

=== debian/changelog ===
neko (2.0.0-4build1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:48:05 +0000

neko (2.0.0-4) unstable; urgency=low

  * Adopt package (Closes: #628939).
    + Set maintainer to myself.
  * Set Vcs-* fields to Haxe Foundation neko-debian git repo.
  * Bump Standards-Version to 3.9.6 (no changes).
  * Bump debhelper and compat level to 9.
  * Clean up d/rules.
  * Include patch to add dpkg-buildflags CFLAGS when compiling ndlls.
  * Add d/watch and get-orig-source target.
  * Convert d/copyright to format 1.0.
  * Add bash-completion, thanks to Tong.
  * Include patch of the upstream fix on JIT.

 -- Andy Li <andy@onthewings.net>  Sat, 19 Sep 2015 02:38:21 +0800

neko (2.0.0-3) unstable; urgency=low

  * QA upload.
  * Convert to dh-apache2.
  * Switch MPM to prefork in postinst; do not depend on apache2-mpm-prefork.

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Jul 2013 15:30:16 +0100

neko (2.0.0-2) unstable; urgency=low

  * QA upload.
  * Update copyright, changed to BSD.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jul 2013 16:32:32 +0200

neko (2.0.0-1) unstable; urgency=low

  * QA upload.
  * New upstream version.
  * Properly orphan the package (see #628939).
  * Build-depend on apache2-dev, fix build errors with apache2.4.
    Closes: #666858.
  * Fix build failure with ld --as-needed. Closes: #641613.
  * Fix some lintian warnings.
  * TODO: Pass build flags to submodules. 

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jul 2013 14:47:28 +0200

=== debian/control ===
Source: neko
Section: interpreters
Priority: optional
Maintainer: Andy Li <andy@onthewings.net>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), pkg-config, libgc-dev, dh-apache2, apache2-dev, libmysqlclient-dev, libsqlite3-dev, libpcre3-dev, libapr1-dev, libgtk2.0-dev, bash-completion
Vcs-Git: https://github.com/HaxeFoundation/neko-debian.git
Vcs-Browser: https://github.com/HaxeFoundation/neko-debian
Homepage: http://nekovm.org

Package: libneko0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: neko (<< 1.8.0-2), neko-dev (<< 1.8.1)
Description: Lightweight virtual machine - shared library
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 This is the shared library implementing the Neko virtual machine.
 .
 Neko was written by Nicolas Cannasse.

Package: neko-dev
Architecture: all
Section: libdevel
Depends: libneko0 (>= ${source:Upstream-Version}), libneko0 (<<  ${source:Upstream-Version}+1~), ${misc:Depends}
Conflicts: neko (<< 1.8.0-2)
Description: Lightweight virtual machine - headers
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 The virtual machine is both very lightweight and well optimized.  It
 can be easily embedded into other applications, and libraries are
 directly accessible using the C foreign function interface.
 .
 This package includes the header files for development using the Neko
 virtual machine.
 .
 Neko was written by Nicolas Cannasse.

Package: neko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libapache2-mod-neko, neko-dev
Description: Lightweight virtual machine - compiler and tools
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 The compiler converts a source file (.neko) into a bytecode file (.n)
 that can be executed with the Virtual Machine.  You can use the
 compiler as standalone commandline executable separated from the
 virtual machine, or as a Neko library to perform compile-and-run for
 interactive languages.
 .
 Neko was written by Nicolas Cannasse.

Package: libapache2-mod-neko
Architecture: all
Section: httpd
Depends: neko (>= ${source:Version}), ${misc:Depends}
Description: Apache module for running server-side Neko programs
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 This package includes a module for Apache 2 so that you can
 dynamically generate server-side web pages from Apache.
 .
 Neko was written by Nicolas Cannasse.

=== debian/rules ===
#!/usr/bin/make -f
## debian/rules for neko.

%:
	dh $@ --with apache2,bash-completion

## Both AMD64 and all kFreeBSDs seem to have problems with the type
## punning used in the Neko source.
ifeq (amd64,$(DEB_HOST_ARCH))
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
endif
ifeq (kfreebsd,$(DEB_HOST_ARCH_OS))
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
endif

override_dh_auto_build:
	dh_auto_build -- \
		CFLAGS="$(CFLAGS) -Wall -fPIC -I vm -DCOMPACT_TABLE -D_GNU_SOURCE -I libs/common" \
		EXTFLAGS="$(LDFLAGS) -pthread" \
		STD_NDLL_FLAGS="$(LDFLAGS) -Lbin -lneko -lm -lrt"

override_dh_auto_install:

override_dh_strip:
	dh_strip -Xnekoc -Xnekotools

override_dh_fixperms:
	dh_fixperms
	find $(CURDIR)/debian -name '*.ndll' -exec chmod -x '{}' ';'

get-orig-source:
	uscan --verbose --rename --force-download

=== debian/watch ===
version=3
http://nekovm.org/download .*/neko-(\d\.\d\.\d)\.tar\.gz

## neko 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(neko C)

set(CMAKE_OSX_ARCHITECTURES x86_64)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

# put output in "bin"

set(OUTPUT_DIR ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_DIR})

# avoid the extra "Debug", "Release" directories
# http://stackoverflow.com/questions/7747857/in-cmake-how-do-i-work-around-the-debug-and-release-directories-visual-studio-2
foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
	string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
	set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
	set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
	set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )

# target_include_directories for old cmake versions
if (${CMAKE_VERSION} VERSION_LESS 2.8.8)
	function(target_include_directories target visibility)
		include_directories(${ARGN})
	endfunction()
elseif (${CMAKE_VERSION} VERSION_LESS 2.8.11)
	function(target_include_directories target visibility)
		set_target_properties(${target}
			PROPERTIES
			INCLUDE_DIRECTORIES "${INCLUDE_DIRECTORIES} ${ARGN}"
		)
	endfunction()
endif()

# add_compile_options for old cmake versions
if (${CMAKE_VERSION} VERSION_LESS 2.8.12)
	macro(add_compile_options)
		foreach(opt ${ARGN})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${opt}")
		endforeach()
	endmacro()
endif()

set(NEKO_VERSION_MAJOR 2)
set(NEKO_VERSION_MINOR 1)
set(NEKO_VERSION_PATCH 0)

configure_file (
	"${CMAKE_SOURCE_DIR}/vm/neko.h.in"
	"${CMAKE_BINARY_DIR}/neko.h"
)

set(ndll_targets
	std.ndll
	zlib.ndll
	mysql.ndll
	mysql5.ndll
	regexp.ndll
	sqlite.ndll
	ui.ndll
	mod_neko2.ndll
	mod_tora2.ndll
	ssl.ndll
)

set(external_deps
	BoehmGC
	Zlib
	OpenSSL
	MariaDBConnector
	PCRE
	Sqlite3
	APR
	APRutil
	Apache
	MbedTLS
)

set(WITH_NDLLS ${ndll_targets} CACHE STRING "A list of ndll files to be built.")

set(STATIC_DEPS_DOC "Dependencies that should be linked statically. Can be \"all\", \"none\", or a list of library names (e.g. \"${external_deps}\").")

if (WIN32)
	set(STATIC_DEPS "all")
else()
	set(STATIC_DEPS "none" CACHE STRING "${STATIC_DEPS_DOC}")

	option(RELOCATABLE "Set RPATH to $ORIGIN (Linux) / @executable_path (Mac)." ON)

	if (NOT APPLE)
		option(RUN_LDCONFIG "Run ldconfig after install." ON)
	endif()
endif()


# These ndll cannot be skipped.
set(core_ndll_targets
	std.ndll
	zlib.ndll
)

# Validate STATIC_DEPS
if (STATIC_DEPS STREQUAL "all")
	set(STATIC_DEPS ${external_deps} CACHE STRING "${STATIC_DEPS_DOC}" FORCE)
elseif (STATIC_DEPS STREQUAL "none")
	message(STATUS "set STATIC_DEPS to nothing")
	set(STATIC_DEPS CACHE STRING "${STATIC_DEPS_DOC}" FORCE)
endif()

foreach(dep ${STATIC_DEPS})
	list(FIND external_deps ${dep} idx)
	if(idx EQUAL -1)
		message(FATAL_ERROR "Invalid STATIC_DEPS. There is no ${dep} in the list of ${external_deps}")
	endif()
endforeach()

# Validate WITH_NDLLS
foreach(ndll ${WITH_NDLLS})
	list(FIND ndll_targets ${ndll} idx)
	if(idx EQUAL -1)
		message(FATAL_ERROR "Invalid WITH_NDLLS. There is no ${ndll} in the list of ${idx}.")
	endif()
endforeach()
foreach(ndll ${core_ndll_targets})
	list(FIND WITH_NDLLS ${ndll} idx)
	if(idx EQUAL -1)
		message(FATAL_ERROR "${ndll} must be built. Add it to WITH_NDLLS.")
	endif()
endforeach()

# Set STATIC_* variables according to STATIC_DEPS.
foreach(dep ${external_deps})
	string(TOUPPER ${dep} var)
	list(FIND STATIC_DEPS ${dep} static_idx)
	if (static_idx EQUAL -1)
		set(STATIC_${var} FALSE)
	else()
		set(STATIC_${var} TRUE)
	endif()
endforeach()

# Set EXCLUDE_*_NDLL_FROM_ALL variables according to WITH_NDLLS.
foreach(ndll ${ndll_targets})
	string(REPLACE . _ var ${ndll})
	string(TOUPPER ${var} var)
	list(FIND WITH_NDLLS ${ndll} ndll_idx)
	if (ndll_idx EQUAL -1)
		set(EXCLUDE_${var}_FROM_ALL EXCLUDE_FROM_ALL)
	else()
		set(EXCLUDE_${var}_FROM_ALL "")
	endif()
endforeach()

include(ExternalProject)


# CMAKE_BUILD_WITH_INSTALL_RPATH should be set to true.
# It is because `nekotools boot` will use the neko in build dir during build.
set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

if (RELOCATABLE)
	# https://cmake.org/Wiki/CMake_RPATH_handling
	set(CMAKE_SKIP_BUILD_RPATH FALSE)
	set(CMAKE_SKIP_INSTALL_RPATH FALSE)
	if(APPLE)
		set(CMAKE_MACOSX_RPATH TRUE)
		set(CMAKE_INSTALL_RPATH @executable_path/)
	elseif(UNIX)
		set(CMAKE_INSTALL_RPATH \$ORIGIN)
	endif()
endif()

if(UNIX AND NOT APPLE)
	add_definitions(-DABI_ELF)
endif()

if(UNIX)
	add_definitions(-D_GNU_SOURCE)
	add_compile_options(-fno-omit-frame-pointer)

	if (${CMAKE_VERSION} VERSION_LESS 2.8.10)
		add_compile_options(-fPIC)
		set(ARG_PIC -DCMAKE_C_FLAGS=-fPIC)
	else()
		set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
		set(ARG_PIC -DCMAKE_POSITION_INDEPENDENT_CODE=TRUE)
	endif()

	# https://github.com/HaxeFoundation/neko/pull/17
	if(CMAKE_SIZEOF_VOID_P EQUAL 4)
		add_compile_options(-mincoming-stack-boundary=2)
	endif()

	find_package(PkgConfig REQUIRED)
endif()

# git is used for source_archive and for applying patch
find_package(Git REQUIRED)

# copy the lib/src folder to build directory
# (if it is a fat archive, there will be external libraries)
if(EXISTS ${CMAKE_SOURCE_DIR}/libs/src)
	file(COPY ${CMAKE_SOURCE_DIR}/libs/src DESTINATION ${CMAKE_BINARY_DIR}/libs)
endif()

# ExternalProject configs
set(EP_CONFIGS
	PREFIX ${CMAKE_BINARY_DIR}/libs
)
if(NOT ${CMAKE_VERSION} VERSION_LESS 3.1)
	list(APPEND EP_CONFIGS
		DOWNLOAD_NO_PROGRESS 1
	)
endif()
if(${CMAKE_VERSION} VERSION_LESS 3.2)
	list(APPEND EP_CONFIGS
		STEP_TARGETS download
	)
else()
	list(APPEND EP_CONFIGS
		INDEPENDENT_STEP_TARGETS download
	)
endif()
set(EP_PROPS
	EXCLUDE_FROM_ALL 1
)


include_directories(
	${CMAKE_BINARY_DIR}
	vm
	libs/common
)

add_library(libneko SHARED
	vm/alloc.c
	vm/builtins.c
	vm/callback.c
	vm/elf.c
	vm/interp.c
	vm/load.c
	vm/objtable.c
	vm/others.c
	vm/hash.c
	vm/module.c
	vm/jit_x86.c
	vm/threads.c
)

add_library(std.ndll MODULE
	libs/std/buffer.c
	libs/std/date.c
	libs/std/file.c
	libs/std/init.c
	libs/std/int32.c
	libs/std/math.c
	libs/std/string.c
	libs/std/random.c
	libs/std/serialize.c
	libs/std/socket.c
	libs/std/sys.c
	libs/std/xml.c
	libs/std/module.c
	libs/common/sha1.c
	libs/std/md5.c
	libs/std/unicode.c
	libs/std/utf8.c
	libs/std/memory.c
	libs/std/misc.c
	libs/std/thread.c
	libs/std/process.c
	libs/std/elf_update.c
)

add_executable(nekovm
	vm/stats.c
	vm/main.c
)

if (STATIC_BOEHMGC)
	if (WIN32)
		ExternalProject_Add(BoehmGC
			${EP_CONFIGS}
			URL http://www.hboehm.info/gc/gc_source/gc-7.1.tar.gz
			URL_MD5 2ff9924c7249ef7f736ecfe6f08f3f9b
			CMAKE_ARGS
				-Wno-dev
				-Denable_threads=ON
				-DCMAKE_USE_WIN32_THREADS_INIT=ON
			PATCH_COMMAND
				${CMAKE_COMMAND} -E copy
					${CMAKE_SOURCE_DIR}/libs/gc/CMakeLists.txt
					${CMAKE_BINARY_DIR}/libs/src/BoehmGC/CMakeLists.txt
				&& cd ${CMAKE_BINARY_DIR}/libs/src/BoehmGC &&
				${GIT_EXECUTABLE} apply --ignore-space-change --ignore-whitespace --whitespace=nowarn --unsafe-paths ${CMAKE_SOURCE_DIR}/libs/gc/av_safety.patch
			INSTALL_COMMAND
				${CMAKE_COMMAND} -E copy_directory
					${CMAKE_BINARY_DIR}/libs/src/BoehmGC/include
					${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/include/gc
		)
		set(GC_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/include)
		set(GC_LIBRARIES
			${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/${CMAKE_CFG_INTDIR}/gcmt-dll.lib
		)
		add_custom_command(OUTPUT ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/gcmt-dll.dll
			DEPENDS BoehmGC
			COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/${CMAKE_CFG_INTDIR}/gcmt-dll.dll ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
		)
		add_custom_target(gcmt-dll.dll ALL
			DEPENDS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/gcmt-dll.dll
		)
		add_dependencies(nekovm gcmt-dll.dll)
	else()
		ExternalProject_Add(libatomic_ops
			${EP_CONFIGS}
			URL http://www.ivmaisoft.com/_bin/atomic_ops/libatomic_ops-7.4.2.tar.gz
			URL_MD5 1d6538604b314d2fccdf86915e5c0857
			CONFIGURE_COMMAND echo skip config
			BUILD_COMMAND echo skip build
			INSTALL_COMMAND echo skip install
		)

		ExternalProject_Add(BoehmGC
			${EP_CONFIGS}
			DEPENDS libatomic_ops
			URL http://hboehm.info/gc/gc_source/gc-7.4.2.tar.gz
			URL_MD5 12c05fd2811d989341d8c6d81f66af87
			PATCH_COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_BINARY_DIR}/libs/src/libatomic_ops ${CMAKE_BINARY_DIR}/libs/src/BoehmGC/libatomic_ops
			CONFIGURE_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/BoehmGC &&
				./configure
					--prefix=${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build
					--enable-threads=posix
					--with-pic
					--enable-shared=no
					--enable-static=yes
					--enable-silent-rules
					--silent
			BUILD_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/BoehmGC &&
				make CFLAGS=-w
			INSTALL_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/BoehmGC && 
				make install
		)

		# don't want to add libatomic_ops to external_deps,
		# but want download_static_deps depends on it
		add_dependencies(BoehmGC-download libatomic_ops-download)

		set(GC_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/include)
		set(GC_LIBRARIES
			${CMAKE_BINARY_DIR}/libs/src/BoehmGC-build/lib/libgc.a
		)
	endif()
	set_target_properties(BoehmGC PROPERTIES ${EP_PROPS})
	add_dependencies(libneko BoehmGC)
else()
	find_package(BoehmGC REQUIRED)
endif()

target_include_directories(libneko PRIVATE ${GC_INCLUDE_DIRS})

target_link_libraries(libneko ${GC_LIBRARIES})
target_link_libraries(std.ndll libneko)
target_link_libraries(nekovm libneko)

if(WIN32)
	target_link_libraries(std.ndll ws2_32)
endif()

if(UNIX)
	find_package(Threads)
	target_link_libraries(libneko dl m ${CMAKE_THREAD_LIBS_INIT})
endif()

set_target_properties(nekovm
	PROPERTIES
	OUTPUT_NAME neko
)

set_target_properties(nekovm libneko
	PROPERTIES
	OUTPUT_NAME neko
)
set_target_properties(libneko
	PROPERTIES
	VERSION ${NEKO_VERSION_MAJOR}.${NEKO_VERSION_MINOR}.${NEKO_VERSION_PATCH}
	SOVERSION ${NEKO_VERSION_MAJOR}
	COMPILE_DEFINITIONS "_USRDLL;NEKOVM_DLL_EXPORTS;NEKO_SOURCES"
)
set_target_properties(std.ndll
	PROPERTIES
	PREFIX ""
	OUTPUT_NAME std
	SUFFIX .ndll
)

######################
# OpenSSL

if (STATIC_OPENSSL)
	if (APPLE)
		if (${CMAKE_OSX_ARCHITECTURES} STREQUAL "i386")
			set(OPENSSL_CONF ./Configure darwin-i386-cc)
		elseif (${CMAKE_OSX_ARCHITECTURES} STREQUAL "x86_64")
			set(OPENSSL_CONF ./Configure darwin64-x86_64-cc)
		endif()
	else()
		set(OPENSSL_CONF ./config)
	endif()
	if (WIN32)
		# perl is needed to run the openssl Configure script...
		find_package(Perl REQUIRED)
		set(OPENSSL_CONFS
			CONFIGURE_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL &&
				${PERL_EXECUTABLE} Configure VC-WIN32 no-asm --prefix=${CMAKE_BINARY_DIR}/libs/src/install-prefix &&
				call ms/do_ms.bat
			BUILD_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL &&
				nmake /S -f ms/nt.mak
			INSTALL_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL && 
				nmake /S -f ms/nt.mak install
		)
	else()
		set(OPENSSL_CONFS
			CONFIGURE_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL &&
				${OPENSSL_CONF} --prefix=${CMAKE_BINARY_DIR}/libs/src/install-prefix
			BUILD_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL &&
				make depend && make
			INSTALL_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/OpenSSL && 
				make install
		)
	endif()
	ExternalProject_Add(OpenSSL
		${EP_CONFIGS}
		URL https://www.openssl.org/source/openssl-1.0.2h.tar.gz
		URL_MD5 9392e65072ce4b614c1392eefc1f23d0
		${OPENSSL_CONFS}
	)
	set_target_properties(OpenSSL PROPERTIES ${EP_PROPS})
	if (WIN32)
		set(OPENSSL_LIBRARIES
			Crypt32
			${CMAKE_BINARY_DIR}/libs/src/install-prefix/lib/libeay32.lib
			${CMAKE_BINARY_DIR}/libs/src/install-prefix/lib/ssleay32.lib
		)
	endif()
endif()

######################
# zlib.ndll

add_library(zlib.ndll MODULE ${EXCLUDE_ZLIB_NDLL_FROM_ALL} libs/zlib/zlib.c)


if (STATIC_ZLIB)
	set(ZLIB_CMAKE_ARGS
		-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/libs/src/install-prefix
		-Wno-dev
	)

=== debian/changelog ===
neko (2.1.0-4) unstable; urgency=medium

  * Updated dependencies of mariadb and mysql (Closes: #843841).
  * Enabled hardening (hardening=+all).

 -- Andy Li <andy@onthewings.net>  Thu, 10 Nov 2016 22:56:04 +0800

neko (2.1.0-3) unstable; urgency=medium

  * Added upstream patches
    + boot-c-1.diff and boot-c-2.diff: build nekoc, nekoml, and 
      nekotools with "nekotools boot -c file.n", such that the 
      output will be valid binaries.
    + tests-1.diff and tests-2.diff: add tests that run nekoc,
      nekoml, and nekotools.

 -- Andy Li <andy@onthewings.net>  Fri, 10 Jun 2016 18:21:00 +0800

neko (2.1.0-2) unstable; urgency=low

  * Added upstream patch, mincoming-stack-boundary.diff, that avoids
    using unavailable compiler flag (Closes: #825903).

 -- Andy Li <andy@onthewings.net>  Tue, 07 Jun 2016 08:16:58 +0800

neko (2.1.0-1) unstable; urgency=low

  * New upstream version.
    + Upstream now uses CMake to build.
    + libneko is now versioned in upstream. (libneko2)
    + The "nekotools booted" binaries can now be stripped correctly.
    + Use MariaDB for compiling mysql.ndll.
    + Updated d/copyright.
  * Fixed shlibdeps for the neko package.
  * Removed patches applied to upstream. Updated hurd.diff.
  * Updated d/watch pattern.
  * Bump Standards-Version to 3.9.8 (no changes).

 -- Andy Li <andy@onthewings.net>  Thu, 19 May 2016 22:00:37 +0800

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,27 @@
 Section: interpreters
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9), pkg-config, libgc-dev, dh-apache2, apache2-dev, libmysqlclient-dev, libsqlite3-dev, libpcre3-dev, libapr1-dev, libgtk2.0-dev, bash-completion
+Standards-Version: 3.9.8
+Build-Depends:
+	debhelper (>= 9),
+	cmake,
+	pkg-config,
+	git,
+	libgc-dev,
+	dh-apache2,
+	apache2-dev,
+	libmariadb-dev-compat | default-libmysqlclient-dev,
+	libsqlite3-dev,
+	libpcre3-dev,
+	libapr1-dev,
+	libgtk2.0-dev,
+	libmbedtls-dev,
+	bash-completion
 Vcs-Git: https://github.com/HaxeFoundation/neko-debian.git
 Vcs-Browser: https://github.com/HaxeFoundation/neko-debian
 Homepage: http://nekovm.org
 
-Package: libneko0
+Package: libneko2
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -24,7 +38,7 @@
 Package: neko-dev
 Architecture: all
 Section: libdevel
-Depends: libneko0 (>= ${source:Upstream-Version}), libneko0 (<<  ${source:Upstream-Version}+1~), ${misc:Depends}
+Depends: libneko2 (>= ${source:Upstream-Version}), libneko2 (<<  ${source:Upstream-Version}+1~), ${misc:Depends}
 Conflicts: neko (<< 1.8.0-2)
 Description: Lightweight virtual machine - headers
  Neko provides a common runtime for several different languages,

=== debian/rules ===
#!/usr/bin/make -f
## debian/rules for neko.

%:
	dh $@ --with apache2,bash-completion

## Both AMD64 and all kFreeBSDs seem to have problems with the type
## punning used in the Neko source.
ifeq (amd64,$(DEB_HOST_ARCH))
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
endif
ifeq (kfreebsd,$(DEB_HOST_ARCH_OS))
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DRUN_LDCONFIG=OFF

# dh_shlibdeps does not see the ndll files as libraries, so we call dpkg-shlibdeps manually
override_dh_shlibdeps:
	dh_shlibdeps
	dpkg-shlibdeps -Tdebian/neko.substvars debian/neko/usr/bin/* debian/neko/usr/lib/neko/*.ndll

get-orig-source:
	uscan --verbose --rename --force-download

=== debian/watch ===
version=3
http://nekovm.org/download .*/neko-(\d\.\d\.\d)-src\.tar\.gz
